// X1turboII DEMONSTRATION (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size) {
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos {
	char fname[FILENAME_MAX];
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[]) {
	char fname[FILENAME_MAX];
	unsigned char id[] = "DEMO         obj";
	int i,trk,sec,size;

	struct fpos md[] = {
		{ "DEMO.obj", 0x0d, 0x01, 0x0961 },	//
		{ "DEMO1",    0x28, 0x01, 0x8200 },	//
		{ "DEMO2",    0x35, 0x0e, 0x4700 },	//
		{ "DEMO3",    0x42, 0x0a, 0x4300 },	//
		{ "",         0,    0,         0 },	// end of table
	};

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	disk.SelectDisk(0);
	disk.SetRecordRange(0x01,0x10);
	// fBXN
	disk.ReadDATA1(0x01, 0x00, 0x01, 0x01, 0x01, buff, 0x100);
	if (!memcmp(&buff[0x41], id, sizeof(id)-1)) {
		printf("X1turboII DEMONSTRATION F܂.\n");
		for (i=0; md[i].sec; i++) {
			fcut(md[i].fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x01, 0x0000, md[i].size);
		}
	}
	return 0;
}

